Index: src/ResolvExpr/Unify.cc
===================================================================
--- src/ResolvExpr/Unify.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/ResolvExpr/Unify.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -773,5 +773,5 @@
 
 			const ast::Type * postvisit( const ast::TypeInstType * typeInst ) {
-				if ( const ast::EqvClass * clz = tenv.lookup( *typeInst ) ) {
+				if ( const ast::EqvClass * clz = tenv.lookup( typeInst->name ) ) {
 					// expand ttype parameter into its actual type
 					if ( clz->data.kind == ast::TypeDecl::Ttype && clz->bound ) {
@@ -811,5 +811,5 @@
 		/// Creates a tuple type based on a list of DeclWithType
 		template< typename Iter >
-		static const ast::Type * tupleFromTypes( Iter crnt, Iter end ) {
+		static ast::ptr< ast::Type > tupleFromTypes( Iter crnt, Iter end ) {
 			std::vector< ast::ptr< ast::Type > > types;
 			while ( crnt != end ) {
@@ -821,5 +821,5 @@
 			}
 
-			return new ast::TupleType{ std::move(types) };
+			return { new ast::TupleType{ std::move(types) } };
 		}
 
@@ -888,5 +888,5 @@
 		}
 
-		static void markAssertionSet( ast::AssertionSet & assns, const ast::VariableExpr * assn ) {
+		static void markAssertionSet( ast::AssertionSet & assns, const ast::DeclWithType * assn ) {
 			auto i = assns.find( assn );
 			if ( i != assns.end() ) {
@@ -900,7 +900,9 @@
 			const ast::FunctionType * type
 		) {
-			for ( auto & assert : type->assertions ) {
-				markAssertionSet( assn1, assert );
-				markAssertionSet( assn2, assert );
+			for ( const auto & tyvar : type->forall ) {
+				for ( const ast::DeclWithType * assert : tyvar->assertions ) {
+					markAssertionSet( assn1, assert );
+					markAssertionSet( assn2, assert );
+				}
 			}
 		}
@@ -1028,5 +1030,5 @@
 
 		void postvisit( const ast::TypeInstType * typeInst ) {
-			assert( open.find( *typeInst ) == open.end() );
+			assert( open.find( typeInst->name ) == open.end() );
 			handleRefType( typeInst, type2 );
 		}
@@ -1034,5 +1036,5 @@
 	private:
 		/// Creates a tuple type based on a list of Type
-		static const ast::Type * tupleFromTypes(
+		static ast::ptr< ast::Type > tupleFromTypes(
 			const std::vector< ast::ptr< ast::Type > > & tys
 		) {
@@ -1169,6 +1171,6 @@
 		auto var2 = dynamic_cast< const ast::TypeInstType * >( type2 );
 		ast::OpenVarSet::const_iterator
-			entry1 = var1 ? open.find( *var1 ) : open.end(),
-			entry2 = var2 ? open.find( *var2 ) : open.end();
+			entry1 = var1 ? open.find( var1->name ) : open.end(),
+			entry2 = var2 ? open.find( var2->name ) : open.end();
 		bool isopen1 = entry1 != open.end();
 		bool isopen2 = entry2 != open.end();
Index: src/SymTab/Mangler.cc
===================================================================
--- src/SymTab/Mangler.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/SymTab/Mangler.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -671,5 +671,5 @@
 					int dcount = 0, fcount = 0, vcount = 0, acount = 0;
 					mangleName += Encoding::forall;
-					for ( auto & decl : ptype->forall ) {
+					for ( const ast::TypeDecl * decl : ptype->forall ) {
 						switch ( decl->kind ) {
 						case ast::TypeDecl::Kind::Dtype:
@@ -686,11 +686,11 @@
 						} // switch
 						varNums[ decl->name ] = std::make_pair( nextVarNum, (int)decl->kind );
-					} // for
-					for ( auto & assert : ptype->assertions ) {
-						ast::Pass<Mangler_new> sub_mangler(
-							mangleOverridable, typeMode, mangleGenericParams, nextVarNum, varNums );
-						assert->var->accept( sub_mangler );
-						assertionNames.push_back( sub_mangler.core.get_mangleName() );
-						acount++;
+						for ( const ast::DeclWithType * assert : decl->assertions ) {
+							ast::Pass<Mangler_new> sub_mangler(
+								mangleOverridable, typeMode, mangleGenericParams, nextVarNum, varNums );
+							assert->accept( sub_mangler );
+							assertionNames.push_back( sub_mangler.core.get_mangleName() );
+							acount++;
+						} // for
 					} // for
 					mangleName += std::to_string( dcount ) + "_" + std::to_string( fcount ) + "_" + std::to_string( vcount ) + "_" + std::to_string( acount ) + "_";
Index: src/SymTab/Validate.cc
===================================================================
--- src/SymTab/Validate.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/SymTab/Validate.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -271,5 +271,5 @@
 	};
 
-	struct InitializerLength {
+	struct ArrayLength : public WithIndexer {
 		/// for array types without an explicit length, compute the length and store it so that it
 		/// is known to the rest of the phases. For example,
@@ -282,9 +282,4 @@
 
 		void previsit( ObjectDecl * objDecl );
-	};
-
-	struct ArrayLength : public WithIndexer {
-		static void computeLength( std::list< Declaration * > & translationUnit );
-
 		void previsit( ArrayType * arrayType );
 	};
@@ -387,10 +382,6 @@
 					FixObjectType::fix, translationUnit);
 			}
-			Stats::Time::TimeCall("Initializer Length",
-				InitializerLength::computeLength, translationUnit);
-			if (!useNewAST) {
-				Stats::Time::TimeCall("Array Length",
-					ArrayLength::computeLength, translationUnit);
-			}
+			Stats::Time::TimeCall("Array Length",
+				ArrayLength::computeLength, translationUnit);
 			Stats::Time::TimeCall("Find Special Declarations",
 				Validate::findSpecialDecls, translationUnit);
@@ -1341,9 +1332,4 @@
 	}
 
-	void InitializerLength::computeLength( std::list< Declaration * > & translationUnit ) {
-		PassVisitor<InitializerLength> len;
-		acceptAll( translationUnit, len );
-	}
-
 	void ArrayLength::computeLength( std::list< Declaration * > & translationUnit ) {
 		PassVisitor<ArrayLength> len;
@@ -1351,5 +1337,5 @@
 	}
 
-	void InitializerLength::previsit( ObjectDecl * objDecl ) {
+	void ArrayLength::previsit( ObjectDecl * objDecl ) {
 		if ( ArrayType * at = dynamic_cast< ArrayType * >( objDecl->type ) ) {
 			if ( at->dimension ) return;
@@ -1361,12 +1347,14 @@
 
 	void ArrayLength::previsit( ArrayType * type ) {
-		if ( type->dimension ) {
-			// need to resolve array dimensions early so that constructor code can correctly determine
-			// if a type is a VLA (and hence whether its elements need to be constructed)
-			ResolvExpr::findSingleExpression( type->dimension, Validate::SizeType->clone(), indexer );
-
-			// must re-evaluate whether a type is a VLA, now that more information is available
-			// (e.g. the dimension may have been an enumerator, which was unknown prior to this step)
-			type->isVarLen = ! InitTweak::isConstExpr( type->dimension );
+		if (!useNewAST) {
+			if ( type->dimension ) {
+				// need to resolve array dimensions early so that constructor code can correctly determine
+				// if a type is a VLA (and hence whether its elements need to be constructed)
+				ResolvExpr::findSingleExpression( type->dimension, Validate::SizeType->clone(), indexer );
+
+				// must re-evaluate whether a type is a VLA, now that more information is available
+				// (e.g. the dimension may have been an enumerator, which was unknown prior to this step)
+				type->isVarLen = ! InitTweak::isConstExpr( type->dimension );
+			}
 		}
 	}
@@ -1474,6 +1462,4 @@
 		}
 	}
-
-	/*
 
 	/// Associates forward declarations of aggregates with their definitions
@@ -1858,8 +1844,6 @@
 		}
 	};
-	*/
 } // anonymous namespace
 
-/*
 const ast::Type * validateType(
 		const CodeLocation & loc, const ast::Type * type, const ast::SymbolTable & symtab ) {
@@ -1870,5 +1854,4 @@
 	return type->accept( lrt )->accept( fpd );
 }
-*/
 
 } // namespace SymTab
Index: src/Tuples/TupleAssignment.cc
===================================================================
--- src/Tuples/TupleAssignment.cc	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ src/Tuples/TupleAssignment.cc	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -504,6 +504,7 @@
 
 			std::vector< ast::ptr< ast::Expr > > match() override {
-				static UniqueName lhsNamer( "__massassign_L" );
-				static UniqueName rhsNamer( "__massassign_R" );
+				// temporary workaround for new and old ast to coexist and avoid name collision
+				static UniqueName lhsNamer( "__massassign_Ln" );
+				static UniqueName rhsNamer( "__massassign_Rn" );
 				// empty tuple case falls into this matcher
 				assert( lhs.empty() ? rhs.empty() : rhs.size() <= 1 );
@@ -534,6 +535,7 @@
 
 			std::vector< ast::ptr< ast::Expr > > match() override {
-				static UniqueName lhsNamer( "__multassign_L" );
-				static UniqueName rhsNamer( "__multassign_R" );
+				// temporary workaround for new and old ast to coexist and avoid name collision
+				static UniqueName lhsNamer( "__multassign_Ln" );
+				static UniqueName rhsNamer( "__multassign_Rn" );
 
 				if ( lhs.size() != rhs.size() ) return {};
Index: tests/Makefile.am
===================================================================
--- tests/Makefile.am	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ tests/Makefile.am	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -103,9 +103,9 @@
 
 mostlyclean-local :
-	find ${builddir} -not -path './__pycache__/*' -path '*.o' -delete
-	find ${builddir} -not -path './__pycache__/*' -path '*/.err/*.log' -delete
-	find ${builddir} -not -path './__pycache__/*' -path '*/.out/*.log' -delete
 	rm -f ${EXTRA_PROGRAMS}
 	rm -rf __pycache__
+	find ${builddir} -path '*.o' -delete
+	find ${builddir} -path '*/.err/*.log' -delete
+	find ${builddir} -path '*/.out/*.log' -delete
 
 distclean-local :
Index: tests/concurrent/futures/basic.cfa
===================================================================
--- tests/concurrent/futures/basic.cfa	(revision 2b4daf23cdfb724c24a5ed13d7d20d9fe2c80590)
+++ tests/concurrent/futures/basic.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -1,4 +1,3 @@
 #include <thread.hfa>
-
 enum {NFUTURES = 10};
 
@@ -84,5 +83,4 @@
 
 int main() {
-	printf( "start\n" );				// non-empty .expect file
 	processor procs[2];
 	{
Index: tests/multi_list.cfa
===================================================================
--- tests/multi_list.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
+++ tests/multi_list.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -0,0 +1,101 @@
+#include <fstream.hfa>
+#include <stdlib.hfa>
+#include <bits/stack.hfa>
+#include <bits/queue.hfa>
+#include <bits/sequence.hfa>
+
+struct Task;											// node type
+
+struct TaskDL {
+	inline Seqable;
+	Task & node;
+};
+void ?{}( TaskDL & this, Task & task ) with( this ) {
+	((Seqable &)this){};
+	&node = &task;										// pointer to containing node
+}
+Task & task( TaskDL & this ) with( this ) {				// getter routine for containing node
+	return node;
+}
+
+struct TaskSL {
+	inline Colable;
+	Task & node;
+};
+void ?{}( TaskSL & this, Task & task ) with( this ) {
+	((Colable &)this){};
+	&node = &task;										// pointer to containing node
+}
+Task & task( TaskSL & this ) with( this ) {				// getter routine for containing node
+	return node;
+}
+
+struct Task {
+	TaskDL clusterRef;									// list of tasks on cluster
+	TaskDL readyRef;									// list of tasks on ready queue
+	TaskSL mutexRef;									// list of tasks on mutex queue
+	int id;
+};
+void ?{}( Task & this, int id ) with( this ) {
+	((TaskDL &)clusterRef){ this };
+	((TaskDL &)readyRef){ this };
+	((TaskSL &)mutexRef){ this };
+	this.id = id;
+}
+
+int main() {
+	Sequence(TaskDL) clustList, readyList;				// task lists
+	Queue(TaskSL) mutexList;
+	enum { Lnth = 10 };
+
+	for ( id; Lnth ) {
+		Task & task = *new( id );						// create task node
+		addHead( clustList, task.clusterRef );			// insert on lists in opposite directions
+		addTail( readyList, task.readyRef );
+		addHead( mutexList, task.mutexRef );
+	}
+
+	SeqIter(TaskDL) sqiter;
+	TaskDL & dl;										// iterator index
+	TaskSL & sl;
+
+	sout | nlOff;
+	for ( over( sqiter, clustList ); sqiter >> dl; ) {	// print lists
+		Task & tmp = task( dl ); sout | tmp.id;
+		// sout | task( dl ).id;
+	}
+	sout | nl;
+	for ( over( sqiter, readyList ); sqiter >> dl; ) {
+		Task & tmp = task( dl ); sout | tmp.id;
+		// sout | task( dl ).id;
+	}
+	sout | nl;
+	for ( QueueIter(TaskSL) qiter = { mutexList }; qiter >> sl; ) {	// print lists
+		Task & tmp = task( sl ); sout | tmp.id;
+		// sout | task( sl ).id;
+	}
+	sout | nl;
+	for ( Lnth ) {										// remove nodes from clustList. mutexList
+		dropHead( clustList );
+		drop( mutexList );
+	}
+	// Simultaneous deletion only safe if all nodes are traversed in same direction.
+	for ( Lnth ) {										// remove nodes from readyList and safe to delete nodes
+		delete( &task( dropHead( readyList ) ) );
+	}
+
+	// Re-purpose Seqable as Colable
+	Stack(TaskDL) mutexStack;
+	for ( id; Lnth ) {
+		Task & task = *new( id );						// create task node
+		push( mutexStack, task.clusterRef );			// insert on lists in opposite directions
+	}
+	for ( StackIter(TaskDL) stiter = { mutexStack }; stiter >> dl; ) {
+		Task & tmp = task( dl ); sout | tmp.id;
+		// sout | task( dl ).id;
+	}
+	sout | nl;
+	for ( Lnth ) {										// remove nodes from readyList and safe to delete nodes
+		delete( &task( pop( mutexStack ) ) );
+	}
+}
Index: tests/queue.cfa
===================================================================
--- tests/queue.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
+++ tests/queue.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -0,0 +1,108 @@
+#include <fstream.hfa>
+#include <stdlib.hfa>									// new, delete
+#include <bits/queue.hfa>
+
+int main() {
+	// Fred test
+
+	struct Fred {
+		inline Colable;									// Plan 9 inheritance
+		int i;
+	};
+	void ?{}( Fred & fred ) { abort(); }
+	void ?{}( Fred & fred, int p ) with( fred ) {
+		i = p;
+	}
+
+	Queue(Fred) fred;
+	QueueIter(Fred) fredIter = { fred };
+	Fred & f;
+
+	sout | nlOff;										// turn off auto newline
+
+	for ( ; fredIter >> f; ) {							// empty list
+		sout | f.i | ' ';
+	}
+	sout | "empty" | nl;
+	
+	for ( i; 10 ) {
+		add( fred, *new( 2 * i ) );
+	}
+
+	for ( QueueIter(Fred) iter = { fred }; iter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+
+	for ( i; 9 ) {
+		delete( &drop( fred ) );
+	}
+
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 10 ) {
+		add( fred, *new( 2 * i + 1 ) );
+	}
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		delete( &f );
+	}
+
+	// Mary test
+
+	struct Mary {
+		inline Fred;									// Plan 9 inheritance
+		int j;
+	};
+	void ?{}( Mary & mary ) { abort(); }
+	void ?{}( Mary & mary, int p ) with( mary ) {
+		((Fred &)mary){ p };
+		j = i = p;
+	}
+
+	Queue(Mary) mary;
+	QueueIter(Mary) maryIter = { mary };
+	Mary & m;
+
+	for ( ; maryIter >> m; ) {							// empty list
+		sout | m.i | m.j | ' ';
+	}
+	sout | "empty" | nl;
+	
+	for ( i; 10 ) {
+		add( mary, *new( 2 * i ) );
+	}
+
+	for ( QueueIter(Mary) iter = { mary }; iter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 9 ) {
+		delete( &drop( mary ) );
+	}
+
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 10 ) {
+		add( mary, *new( 2 * i + 1 ) );
+	}
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		delete( &m );
+	}
+}
Index: tests/sequence.cfa
===================================================================
--- tests/sequence.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
+++ tests/sequence.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -0,0 +1,138 @@
+#include <fstream.hfa>
+#include <stdlib.hfa>									// new, delete
+#include <bits/sequence.hfa>
+
+int main() {
+	// Fred test
+
+	struct Fred {
+		inline Seqable;									// Plan 9 inheritance
+		int i;
+	};
+	void ?{}( Fred & fred ) { abort(); }
+	void ?{}( Fred & fred, int p ) with( fred ) {
+		i = p;
+	}
+
+	Sequence(Fred) fred;
+	SeqIter(Fred) fredIter = { fred };
+	Fred & f;
+
+	sout | nlOff;										// turn off auto newline
+
+	for ( ; fredIter >> f; ) {							// empty list
+		sout | f.i | ' ';
+	}
+	sout | "empty" | nl;
+	
+	for ( i; 10 ) {
+		add( fred, *new( 2 * i ) );
+	}
+
+	for ( SeqIter(Fred) iter = { fred }; iter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+
+	for ( i; 9 ) {
+		delete( &dropHead( fred ) );
+	}
+
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 10 ) {
+		addTail( fred, *new( 2 * i + 1 ) );
+	}
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+
+	for ( i; 9 ) {
+		delete( &dropTail( fred ) );
+	}
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		delete( &f );
+	}
+
+	// Mary test
+
+	struct Mary {
+		inline Fred;									// Plan 9 inheritance
+		int j;
+	};
+	void ?{}( Mary & mary ) { abort(); }
+	void ?{}( Mary & mary, int p ) with( mary ) {
+		((Fred &)mary){ p };
+		j = p;
+	}
+
+	Sequence(Mary) mary;
+	Sequence(Mary) baz;
+	SeqIter(Mary) maryIter = { mary };
+	Mary & m;
+
+	for ( ; maryIter >> m; ) {							// empty list
+		sout | m.i | m.j | ' ';
+	}
+	sout | "empty" | nl;
+	
+	for ( i; 10 ) {
+		add( mary, *new( 2 * i ) );
+		add( baz, *new( 2 * i ) );
+	}
+
+	for ( SeqIter(Mary) iter = { mary }; iter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 9 ) {
+		delete( &dropHead( mary ) );
+	}
+
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 10 ) {
+		addTail( mary, *new( 2 * i + 1 ) );
+	}
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+
+	for ( i; 9 ) {
+		delete( &dropTail( mary ) );
+	}
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+
+	transfer( mary, baz );
+
+	for ( over( maryIter, baz ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | "empty" | nl;
+
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		delete( &m );
+	}
+}
Index: tests/stack.cfa
===================================================================
--- tests/stack.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
+++ tests/stack.cfa	(revision 42f6e07e6f562d26e2a4c552e12cfcd2f2660dce)
@@ -0,0 +1,108 @@
+#include <fstream.hfa>
+#include <stdlib.hfa>									// new, delete
+#include <bits/stack.hfa>
+
+int main() {
+	// Fred test
+
+	struct Fred {
+		inline Colable;									// Plan 9 inheritance
+		int i;
+	};
+	void ?{}( Fred & fred ) { abort(); }
+	void ?{}( Fred & fred, int p ) with( fred ) {
+		i = p;
+	}
+
+	Stack(Fred) fred;
+	StackIter(Fred) fredIter = { fred };
+	Fred & f;
+
+	sout | nlOff;										// turn off auto newline
+
+	for ( ; fredIter >> f; ) {							// empty list
+		sout | f.i | ' ';
+	}
+	sout | "empty" | nl;
+	
+	for ( i; 10 ) {
+		push( fred, *new( 2 * i ) );
+	}
+
+	for ( StackIter(Fred) iter = { fred }; iter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 9 ) {
+		delete( &pop( fred ) );
+	}
+
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 10 ) {
+		push( fred, *new( 2 * i + 1 ) );
+	}
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		sout | f.i | ' ';
+	}
+	sout | nl;
+
+	for ( over( fredIter, fred ); fredIter >> f; ) {
+		delete( &f );
+	}
+
+	// Mary test
+
+	struct Mary {
+		inline Fred;									// Plan 9 inheritance
+		int j;
+	};
+	void ?{}( Mary & mary ) { abort(); }
+	void ?{}( Mary & mary, int p ) with( mary ) {
+		((Fred &)mary){ p };
+		j = i = p;
+	}
+
+	Stack(Mary) mary;
+	StackIter(Mary) maryIter = { mary };
+	Mary & m;
+
+	for ( ; maryIter >> m; ) {							// empty list
+		sout | m.i | m.j | ' ';
+	}
+	sout | "empty" | nl;
+	
+	for ( i; 10 ) {
+		push( mary, *new( 2 * i ) );
+	}
+
+	for ( StackIter(Mary) iter = { mary }; iter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 9 ) {
+		delete( &pop( mary ) );
+	}
+
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+	
+	for ( i; 10 ) {
+		push( mary, *new( 2 * i + 1 ) );
+	}
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		sout | m.i | m.j | ' ';
+	}
+	sout | nl;
+
+	for ( over( maryIter, mary ); maryIter >> m; ) {
+		delete( &m );
+	}
+}
